;
; Np
;

	relaxed on

Disk_Entry	equ	$4000
Disk_Init	equ	Disk_Entry + 0
Disk_Load	equ	Disk_Entry + 3
Disk_Change1DD	equ	Disk_Entry + 12

LoadByte	equ	$4200
LoadInit	equ	$4203
LoadPointer	equ	$42fd
Disk_Buf	equ	$4300
KeyBuffer	equ	$4400
ListBuffer	equ	$4500


	org	$0000
	phase	$f900

;
; Track#0 Sector#1`
;
	db	"RXR"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de		; i[AhX
	call	$4274		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c		; ZN^ԍ
	ld	a,c
	cp	$11
	jr	c,.lp1
	ld	c,$01
	inc	b		; gbNԍ
.lp1:	pop	af
	dec	a
	jr	nz,.loop
	ret

START:

;
; u[gvȎǂݍ
;
	xor	a		; hCuԍ-1
	ld	(ix+0),a
	ld	(ix+27),a	; G[JEg
	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$cc00	; i[AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

	ld	(SPPT+1),sp
	ld	sp,$cc00
	push	ix
	push	iy

;
; u[gpfBXN[`ǂݍ
;
	ld	bc,$0005	; BregFgbNԍACregFZN^ԍihCupǂݏo[`j
	ld	a,($fe74)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fdboot_in
	ld	bc,$0007	; BregFgbNԍACregFZN^ԍiOthCupǂݏo[`j
.fdboot_in:
	ld	de,Disk_Entry	; i[擪AhX
	ld	a,$02		; ǂݍރZN^
	call	READ_NSEC

;
; CLOADpb`vOǂݍ
;
	ld	bc,$0009	; BregFgbNԍACregFZN^ԍihCupǂݏo[`j
	ld	de,LoadByte	; i[擪AhX
	ld	a,$01		; ǂݍރZN^
	call	READ_NSEC

	call	CCLS

	ld	de,VER_MSG
	call	PNT_MSG

	jp	MAIN


VER_MSG:
	db	"NandemoP6FDSR ver1.0",$0d,$0d,$00

DISKNG_MSG:
	db	"Disk error",$00

	dephase

	org	$0100
	phase	$cc00

MAIN:

;
; N60-BASICRAMɃRs[
;
	ld	hl,$0000
	ld	de,$0000
	ld	bc,$4000
	ldir

;
; 0x0000`0x7FFFRAMǂݏoɐݒ
;
	di
	ld	a,$dd
	out	($f0),a

;
; u[gpfBXN[`̏
;
	ld	d,$00
	call	Disk_Init	; Init
	jp	c,DISKNG

	ld	d,$00
	call	Disk_Change1DD	; set 1DD
	jp	c,DISKNG

;
; t@CXgǂݏo
;
READLIST:
	ld	de,$000a	; DE=gbNԍ/ZN^ԍ
	ld	hl,LoadPointer
	ld	(hl),$00
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d

	ld	hl,ListBuffer
	call	LoadInit
	ld	(hl),a
	inc	hl
	ld	b,a		; t@C

	call	LoadByte
	ld	(hl),a
	inc	hl
	ld	e,a		; ^CgXW
	call	LoadByte
	ld	(hl),a
	inc	hl
	ld	d,a		; ^CgYW

	ld	de,$0104	; XY=04,01Œ
	ld	(CUR_XY_INIT),de; ^CgXYW

.lp1:
	call	LoadByte
	ld	(hl),a
	inc	hl
	or	a
	jr	nz,.lp1

	push	hl
	pop	ix		; t@CXg̐擪

.lp3:
	call	LoadByte
	ld	(hl),a		; ZN^ԍ
	inc	hl
	call	LoadByte
	ld	(hl),a		; gbNԍ
	inc	hl

.lp2:
	call	LoadByte
	ld	(hl),a
	inc	hl
	or	a
	jr	nz,.lp2

	djnz	.lp3


	ld	c,0
	ld	hl,ListBuffer+1
	ld	a,(hl)
	inc	a
	jp	z,SETPROG	; autostart̏ꍇ

;
; vOIpj[
;
MENU:
	ld	c,0		; y[Wԍit@CPOłPy[Wj

			;
			; ^Cgꗗ\iőPOt@Cj
			;
.st:
	call	CCLS
	ld	hl,(CUR_XY_INIT)	; ^CgXYW
	ld	(CUR_XY),hl		; ^CgXYW
	ld	de,ListBuffer+3
	call	PNT_MSG		; ^Cg\

	ld	b,0		; ԏ̃t@Cԍi0`9j
	inc	h		; YWP
.lp1:
	inc	h		; YWP
	ld	(CUR_XY),hl
	call	PNT_TITLE

	inc	b
	ld	a,b
	cp	10
	jr	nc,.mend

	ld	a,(ListBuffer)	; S̃t@C
	ld	e,a

	ld	a,b
	add	a,c
	cp	e
	jr	c,.lp1

.mend:

			;
			; Õy[WÃy[W̕\
			;
	ld	a,(ListBuffer)	; S̃t@C
	ld	b,a

	ld	a,c
	cp	10
	jr	c,.np1
	ld	hl,$0e01
	ld	(CUR_XY),hl
	ld	de,PNT_BACK
	call	PNT_MSG
.np1:

	ld	a,c
	add	a,10
	cp	b		; S̃t@C
	jr	nc,.np2

	ld	hl,$0e13
	ld	(CUR_XY),hl
	ld	de,PNT_NEXT
	call	PNT_MSG
.np2:

	push	bc
	call	$1058		; L[obt@NA
	pop	bc

.lp2:
	call	$0fbc		; P
	jr	z,.lp2
	cp	"n"
	jr	nz,.k1
	ld	a,c
	add	a,10
	cp	b		; S̃t@C
	jr	nc,.lp2
	ld	c,a
	jr	.st

.k1:
	cp	"b"
	jr	nz,.k2
	ld	a,c
	sub	10
	jr	c,.lp2
	ld	c,a
	jr	.st

.k2:
	sub	"0"
	add	a,c
	cp	b
	jr	nc,.lp2

	ld	c,a

;
; vO̐擪|C^i[
;
SETPROG:
	push	ix
	pop	hl
.lp1:
	ld	a,c
	or	a
	jr	z,.match

	inc	hl		; ZN^ԍ
	inc	hl		; gbNԍ
.lp2:
	ld	a,(hl)		; vO
	inc	hl
	or	a
	jr	nz,.lp2

	dec	c
	jr	.lp1

.match:
	ld	e,(hl)
	inc	e		; ZN^ԍ̃ItZbg
	inc	hl
	ld	d,(hl)
	inc	d		; gbNԍ̃ItZbg
	inc	d		; gbNԍ̃ItZbg

	ld	hl,LoadPointer
	ld	(hl),$00
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d

;
; [hݒi1 or 2j
;
	call	LoadInit
	sub	"1"
	ld	($ff4e),a	; A=0MODE1 / A=1MODE2
	call	LoadByte	; _~[

;
; y[WAR}hݒ
;
	ld	de,KeyBuffer	; L[obt@擪
	ld	($fb8d),de
	ld	b,0
.lp3:
	call	LoadByte
	cp	"*"
	jr	z,.setkey
	ld	(de),a
	inc	hl
	inc	de
	inc	b
	jr	.lp3

.setkey:
	ld	a,b
	ld	($fa32),a

;
; ѐɃpb`𓖂Ă
;
	ld	a,$c3
	ld	($1a70),a	; CMTP
	ld	hl,LoadByte
	ld	($1a71),hl
	ld	a,$c9
	ld	($1a61),a	; CMT[hCjVCY
	ld	($1aaa),a	; CMT[hpI
	ld	($1b49),a	; CMT[^ON
	ld	($1b4b),a	; CMT[^OFF

;
; oN؊Ƀpb`𓖂Ă
;
	ld	a,$dd
	ld	($2693),a
	ld	($2697),a

;
; 0x4000`0x7FFFBASICɖ߂
;
	ld	a,$1d
	out	($f0),a

	pop	iy
	pop	ix
SPPT:	ld	sp,$0000
	ei

	ret


PAGE:	db	$00

;
; fBXNG[\
;
DISKNG:
	ld	de,DISKNG_MSG
	call	PNT_MSG
	jr	$

;
; ʃNA
;
CCLS:
	push	hl
	ld	hl,$c000
.lp1:	ld	(hl),$20
	inc	hl
	ld	a,h
	cp	$c4
	jr	nz,.lp1
	pop	hl
	ret

;
; \
;
PNT_MSG:
	push	bc
	push	hl
	ld	bc,(CUR_XY)

.lp1:
	ld	a,(de)
	inc	de
	or	a
	jr	z,.end

	cp	$0d
	jr	nz,.nom
	ld	c,0
	inc	b
	jr	.lp1

.nom:
	push	bc
	ld	l,b
	ld	h,0
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	add	hl,hl		; x16
	add	hl,hl		; x32
	ld	b,$c2		; VRAMy[Wݒ
	add	hl,bc
	pop	bc

	ld	(hl),a
	inc	c

	ld	a,c
	cp	32
	jr	c,.lp1
	ld	c,0
	inc	b
	jr	.lp1

.end:
	ld	(CUR_XY),bc
	pop	hl
	pop	bc
	ret

CUR_XY:
	dw	$0000
CUR_XY_INIT:
	dw	$0000

;
; ^Cg̈\
;
; BFt@Cԍi0`9j
; CFy[Wԍi0,10,20,...j
; IXFt@CXg̐擪
;
PNT_TITLE:
	push	bc
	push	de
	push	hl

	ld	de,PNT_NUM
	ld	a,b
	add	a,"0"
	ld	(de),a
	call	PNT_MSG

	ld	a,b
	add	a,c
	ld	b,a

	push	ix
	pop	de
.lp1:
	inc	b
	dec	b
	jr	z,.lp3
	inc	de
	inc	de

.lp2:
	ld	a,(de)
	inc	de
	or	a
	jr	nz,.lp2

	dec	b
	jr	.lp1

.lp3:
	inc	de
	inc	de
	call	PNT_MSG

	pop	hl
	pop	de
	pop	bc
	ret

PNT_NUM:
	db	"0:",0x00
PNT_BACK:
	db	"b:",0xef,0x94,0xe9,"߰",0xed,0x00
PNT_NEXT:
	db	"n:",0xe2,0x97,0xde,0xe9,"߰",0xed,0x00

	dephase

	org	$0400
	phase	Disk_Entry

	include	"disk66.z80"

	dephase

	org	$0600
	phase	Disk_Entry

	include	"disk.z80"

	dephase

	org	$07ff
	db	$ff

end

